import { ElementRef, EventEmitter, NgZone, Renderer } from '@angular/core';
import { Content } from '../content/content';
import { Item } from './item';
export interface ReorderIndexes {
    from: number;
    to: number;
}
/**
 * @private
 */
export declare class Reorder {
    private _rendered;
    private _zone;
    private _content;
    private _enableReorder;
    private _reorderGesture;
    private _lastToIndex;
    private _element;
    ionItemReorder: EventEmitter<ReorderIndexes>;
    constructor(elementRef: ElementRef, _rendered: Renderer, _zone: NgZone, _content: Content);
    /**
     * @private
     */
    ngOnDestroy(): void;
    reorder: boolean;
    /**
     * @private
     */
    reorderStart(): void;
    /**
     * @private
     */
    reorderEmit(fromIndex: number, toIndex: number): void;
    /**
     * @private
     */
    scrollContent(scroll: number): number;
    /**
     * @private
     */
    reorderReset(): void;
    /**
     * @private
     */
    reorderMove(fromIndex: number, toIndex: number, itemHeight: number): void;
    /**
     * @private
     */
    setCssClass(classname: string, add: boolean): void;
    /**
     * @private
     */
    getNativeElement(): HTMLElement;
}
/**
 * @private
 */
export declare class ItemReorder {
    private item;
    private elementRef;
    constructor(item: Item, elementRef: ElementRef);
    ngAfterContentInit(): void;
}
